freeslot("SPR_FEHN","MT_FEHNSHIELD","S_FEHN_DIVE","S_FEHN_SHIELD1","SFX_FHNJUM", "SFX_FHNDJ", "SFX_FHNSPN", "SFX_FHNSHD", "SFX_PLSE", "SFX_LILJ")

sfxinfo[sfx_fhndj].caption = "Double Jump"
sfxinfo[sfx_fhnshd].caption = "Crystal Shield"
sfxinfo[sfx_plse].caption = "Goat horn attac"
sfxinfo[sfx_lilj].caption = "Little jump"

mobjinfo[MT_FEHNSHIELD] = {
	doomednum = -1,
	spawnstate = S_FEHN_SHIELD1,
	height = 32*FRACUNIT,
	radius = 64*FRACUNIT,
	activesound = sfx_fhnshd, 
	flags =  MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT
}

states[S_FEHN_DIVE] = {
	sprite = SPR_FEHN,
	frame = A|FF_ANIMATE,
	tics = -1,
	var1 = 1,
    var2 = 5
}

states[S_FEHN_SHIELD1] = {
	sprite = SPR_FEHN,
	frame = B|TR_TRANS40,
	tics = 2,
	nextframe = S_NULL
}

addHook("AbilitySpecial", function(player)
	if (player.mo.skin ~= "fehn") return end
	if (player.pflags & PF_THOKKED) return end
	if (player.canD == false) return end
	player.canD = false
	S_StartSound(player.mo, sfx_fhndj)
	player.pflags = $1|PF_THOKKED
	player.mo.state = S_PLAY_SPRING
	if (player.mo.momz >= 0)
		player.mo.momz = $1/2+10*FRACUNIT*P_MobjFlip(player.mo)
	else
		player.mo.momz = 10*FRACUNIT*P_MobjFlip(player.mo)
	end
	for i = 1, 8
		local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + (player.mo.eflags & MFE_VERTICALFLIP and 4*player.mo.scale or 0), player.mo.eflags & (MFE_UNDERWATER | MFE_TOUCHWATER) and MT_MEDIUMBUBBLE or MT_PARTICLE)
		dust.fuse = TICRATE/2
		dust.scale = player.mo.scale
		dust.destscale = player.mo.scale/8
		P_InstaThrust(dust, i*ANGLE_45, 4*player.mo.scale)
		dust.momz = -2*FRACUNIT*P_MobjFlip(player.mo)
		dust.frame = $1|TR_TRANS60
	end
	return false
end)

addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "fehn") and (player.playerstate == PST_LIVE)
		if (P_IsObjectOnGround(player.mo))
			if (player.cmd.buttons & BT_JUMP)
			and not (player.pflags & PF_JUMPED)
				P_DoJump(player)
			end
		end
		if not (player.dive)
			player.dive = false
		end
		if not (player.canD)
			player.canD = true
		end
		if not (player.fehnshield)
			player.fehnshield = 0
		end
		if not (player.canshield)
			player.canshield = 0
		end
		if (player.powers[pw_carry] ~= CR_NONE)
		or P_CheckDeathPitCollide(player.mo)	
		or (player.pflags & PF_SHIELDABILITY)
		or (player.playerstate ~= PST_LIVE)
		or (player.mo.state == S_PLAY_PAIN)
			player.dive = false
			player.canD = false
		end
		if (player.dive)
			player.drawangle = player.mo.angle
            player.mo.state = S_FEHN_DIVE
			player.thrustfactor = skins[player.mo.skin].thrustfactor/3
			player.height = 24*FRACUNIT
		else
			player.thrustfactor = skins[player.mo.skin].thrustfactor
			player.height = skins[player.mo.skin].height
		end
		if (player.cmd.buttons & BT_TOSSFLAG)
		and (player.canshield == 0)
			if (player.fehnshield == 0)
			and (player.rings > 5)
				player.fehnshield = 1
				player.rings = $ - 1
				player.canshield = 1
				S_StartSound(mobj, sfx_fhnshd)
			elseif (player.fehnshield >= 35)
				player.fehnshield = 0
				player.canshield = 1
			end
		end
		if (player.canshield > 0)
			player.canshield = $ + 1
		end
		if (player.canshield >= 35)
			player.canshield = 0
		end
		if player.pflags & player.powers[pw_justsprung]
		and not P_IsObjectOnGround(player.mo)
		S_StartSound(player.mo, sfx_fhndj)
			player.mo.state = S_PLAY_ROLL
			player.pflags = $1|PF_JUMPED
			player.dive = false
		end
		if (player.fehnshield > 0)
			player.fehnshield = $ + 1
			local sh = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_FEHNSHIELD)
			sh.momx = player.mo.momx
			sh.momy = player.mo.momy
			sh.momz = player.mo.momz
			P_SpawnGhostMobj(sh)
			sh.scale = $ * 2
			if (leveltime % 35 == 0)
				if (player.rings == 0)
					player.fehnshield = 0
				else
					player.rings = $ - 1
				end
			end
		end
		if (player.dive == false)
		and not (P_IsObjectOnGround(player.mo))
		and (player.cmd.buttons & BT_USE)
		and (player.canD == true)
		and not (player.powers[pw_shield])
		S_StartSound(player.mo, sfx_plse)
			player.drawangle = player.mo.angle
			player.mo.momz = 6*FRACUNIT*P_MobjFlip(player.mo)
			player.dive = true
			if (player.speed < 40*FRACUNIT)
				if (player.speed < 20*FRACUNIT)
					P_InstaThrust(player.mo, player.mo.angle, 36*FRACUNIT)
				else
					P_InstaThrust(player.mo, player.mo.angle, player.speed+12*FRACUNIT)
				end
			else
				P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT)
			end 
		end
		if (P_IsObjectOnGround(player.mo))
		and (player.dive == true)

//i wanted to give the little jump sound called "dslilj" but can't, can ya help me? -fehn
		then 
			S_StartSound(player.mo, sfx_lilj)
			player.dive = false
			player.canD = false
			player.mo.state = S_PLAY_ROLL
			player.mo.momz = 4*FRACUNIT*P_MobjFlip(player.mo)
			player.pflags = $1|PF_JUMPED
		end
		if (P_IsObjectOnGround(player.mo))
			player.canD = true
		end
	end
end)

addHook('ThinkFrame', do
	for player in players.iterate do
		if player.mo and player.mo.scale and player.mo.friction and player.mo.movefactor then
			local pmo = player.mo
			if pmo.skin ~= "fehn" return end
			//Create history
			if player.waterlast == nil then
				player.waterlast = false
				player.dashlast = false
				player.realfriction = pmo.friction
			end
			local skin = skins[pmo.skin]
			
			//Stat adjust
			if player.charability2 == CA2_SPINDASH then
				player.mindash = skin.mindash * 3/2
			end
			local water = 1+(pmo.eflags&MFE_UNDERWATER)/MFE_UNDERWATER //Water factor for momentum halving
			local grounded = P_IsObjectOnGround(pmo)
			local nmom = skin.normalspeed //Skin normalspeed, the integral component
			//Dashmode overrides skin normalspeed
			if player.dashmode >= 3*TICRATE then
				nmom = player.normalspeed
			end
			
			local scale = pmo.scale //Normalspeed calculations are affected by scale
			local friction = FixedDiv(pmo.friction,pmo.movefactor) //Reversing friction is required for sustaining ground momentum
			local pmom = FixedDiv(FixedHypot(player.rmomx,player.rmomy),scale) //Current speed, scaled for normalspeed calculations
			local pwup = (player.powers[pw_sneakers]) or (player.powers[pw_super]) //Speed-ups multiply max allowed speed by 5/3
			local momangle = R_PointToAngle2(0,0,player.rmomx,player.rmomy) //Used for angling new momentum in ability cases
			//Adjust current speed reading for calculations with pwup status
			if pwup then
				pmom = $*3/5
			end
			local mom = FixedHypot(pmo.momx,pmo.momy)		
			
			/////////
			//General momentum scaling
			
			//Do landing momentum cut
			if pmo.eflags&MFE_JUSTHITFLOOR then
				player.normalspeed = skin.normalspeed
				pmo.friction = $-$/10
			//Do ground momentum
			elseif grounded then
				//The amount of momentum to sustain
				local sustain = FixedDiv(min(pmom*water,nmom*2),friction)
-- 				if pmom > player.normalspeed then
					player.normalspeed = max(nmom,sustain)
-- 				end
			//Do air momentum
			elseif not(player.dashmode) then //Dashmode overrides normalspeed in the air
				player.normalspeed = skin.normalspeed
			end
			
			//Update history
			player.waterlast = (pmo.eflags&MFE_UNDERWATER > 0)
			player.dashlast = (player.pflags&PF_STARTDASH > 0)
		end
	end
end)

addHook("MobjDamage", function(target, inflictor, source)
	if (target.valid) and (target.player) and (target.player.fehnshield > 0)
		if not (inflictor) and not (source)
			P_DoPlayerPain(target.player)
			return true
		else
			P_DoPlayerPain(target.player, source, inflictor)
			P_DamageMobj(source, inflictor, target)
			return true
		end
	end
end)

hud.add(function(v, p)
	if not p.mo return end
	if (p.mo.skin ~= "fehn") return end
	if (p.dive)
		v.drawString(146, 192, "\x81 Spin: Dive", V_90TRANS|V_ALLOWLOWERCASE, "small")
		if (P_IsObjectOnGround(p.mo))
			v.drawString(230, 192, "\x82 Jump: Recovery", V_50TRANS|V_ALLOWLOWERCASE, "small")
		else
			v.drawString(230, 192, "\x82 Jump: Recovery", V_90TRANS|V_ALLOWLOWERCASE, "small")
		end
	else
		v.drawString(146, 192, "\x81 Spin: Dive", V_90TRANS|V_ALLOWLOWERCASE, "small")
	end
	if (p.fehnshield)
		v.drawString(20, 192, "\x83 Toss Flag: Shield", V_90TRANS|V_ALLOWLOWERCASE, "small")
	else
		v.drawString(20, 192, "\x83 Toss Flag: Shield", V_50TRANS|V_ALLOWLOWERCASE, "small")
	end
end)

addHook("PlayerThink",function(player)
  if (player.mo.valid) and (player.mo.skin == "fehn") and (player.mo.state == S_PLAY_SPRING)
    player.mo.state = S_PLAY_SPRING
    
  end
end)

local function doFehn(mobj)
	if (mobj.player.dive == true)
		mobj.state = S_PLAY_ROLL
		mobj.player.dive = false
		mobj.player.canD = false
	end
end

local function fehnCheck(mobj, line)
    local cursec = line.frontsector
    if mobj.subsector.sector == cursec then cursec = line.backsector end

    if not cursec then
		doFehn(mobj, line)
        return true
    end
	
    local fheight = cursec.floorheight
    local cheight = cursec.ceilingheight

    if cursec.f_slope then
        fheight = P_GetZAt(cursec.f_slope, mobj.x + mobj.momx, mobj.y + mobj.momy)
    end
    if cursec.c_slope then
        cheight = P_GetZAt(cursec.c_slope, mobj.x + mobj.momx, mobj.y + mobj.momy)
    end

    if (mobj.z + mobj.height/2 < fheight or mobj.z + mobj.height/2 > cheight) then
		doFehn(mobj, line)
        return true
    else
        for rov in cursec.ffloors() do
            if rov.flags & FF_SOLID then
                if (mobj.z + mobj.height/2 > rov.bottomheight and mobj.z + mobj.height/2 < rov.topheight) then
					doFehn(mobj, line)
                    return true
                end
            end
        end
    end 
end

addHook("MobjLineCollide", function(mobj, line)
	if (mobj.player.skin == "fehn")
		fehnCheck(mobj, line)
	end
end, MT_PLAYER)